import '@things-factory/form-ui'
import '@things-factory/grist-ui'

import gql from 'graphql-tag'
import { css, html } from 'lit-element'
import { connect } from 'pwa-helpers/connect-mixin'

import { i18next, localize } from '@things-factory/i18n-base'
import { client, PageView, store } from '@things-factory/shell'
import { flattenObject } from '@things-factory/utils'
import { VAS_TYPES } from '@things-factory/sales-ui/client/constants/vas'

function formatLocalDate(date = new Date()) {
  const year = date.getFullYear()
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const day = String(date.getDate()).padStart(2, '0')
  return `${year}-${month}-${day}`
}

class VasReport extends connect(store)(localize(i18next)(PageView)) {
  static get styles() {
    return css`
      :host {
        display: flex;
        flex-direction: column;
        width: 100%;
      }

      data-report {
        flex: 1;
      }
    `
  }

  static get properties() {
    return {
      _searchFields: Object,
      _config: Object,
      _partners: Object,
      _partnerId: String,
      _partnerName: String,
      data: Object
    }
  }

  get context() {
    return {
      title: i18next.t('title.vas_summary_report'),
      printable: {
        accept: ['preview'],
        content: this
      },
      exportable: {
        name: i18next.t('title.date_vas_summary_report', {
          state: {
            text: (() => {
              let date = new Date()
              return date.getFullYear().toString() + (date.getMonth() + 1).toString() + date.getDate().toString()
            })()
          }
        }),
        data: this._exportableData.bind(this)
      },
      help: 'operato-wms/report/vas-report'
    }
  }

  get report() {
    return this.shadowRoot.querySelector('data-report')
  }

  get searchForm() {
    return this.shadowRoot.querySelector('search-form')
  }

  get _bizplaceSelector() {
    return this.searchForm.shadowRoot.querySelector('select[name=bizplace]')
  }

  get _fromDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=fromDate]')
  }

  get _toDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=toDate]')
  }

  render() {
    return html`
      <search-form id="search-form" .fields=${this._searchFields} @submit=${e => this.report.fetch()}></search-form>

      <data-report .config=${this._config} .fetchHandler=${this.fetchHandler.bind(this)}></data-report>
    `
  }

  get searchFields() {
    const type = VAS_TYPES
    return [
      {
        label: i18next.t('field.company'),
        name: 'bizplace',
        type: 'select',
        options: [
          { value: '' },
          ...this._partners
            .map(partner => {
              return {
                name: `${partner.name} ${partner.description ? `(${partner.description})` : ''}`,
                value: partner.id
              }
            })
            .sort(this._compareValues('name', 'asc'))
        ],
        props: { searchOper: 'eq' }
      },
      {
        label: i18next.t('field.from_date'),
        name: 'fromDate',
        type: 'date',
        props: {
          searchOper: 'eq',
          max: formatLocalDate(new Date())
        },
        value: (() => {
          const date = new Date()
          date.setMonth(date.getMonth() - 1)
          return formatLocalDate(date)
        })(),
        handlers: { change: this._modifyDateRange.bind(this) }
      },
      {
        label: i18next.t('field.to_date'),
        name: 'toDate',
        type: 'date',
        props: {
          searchOper: 'lte',
          max: formatLocalDate(new Date())
        },
        value: formatLocalDate(new Date()),
        handlers: { change: this._modifyDateRange.bind(this) }
      },
      {
        label: i18next.t('field.vas'),
        name: 'vas',
        type: 'string',
        props: { searchOper: 'i_like' }
      },
      {
        label: i18next.t('field.type'),
        name: 'type',
        type: 'select',
        options: [
          { value: '' },
          ...Object.values(type)
            .map(type => {
              return {
                name: type,
                value: type
              }
            })
            .sort()
        ],
        props: { searchOper: 'eq' }
      }
    ]
  }

  get reportConfig() {
    return {
      rows: {
        selectable: false,
        groups: [{ column: 'bizplaceName' }],
        totals: ['vasQty']
      },
      columns: [
        {
          type: 'string',
          name: 'bizplaceName',
          header: i18next.t('field.company'),
          sortable: false,
          imex: { header: i18next.t('field.company'), key: 'bizplaceName', width: 30, type: 'string' },
          width: 200
        },
        {
          type: 'string',
          name: 'vas',
          header: i18next.t('field.vas'),
          sortable: false,
          imex: { header: i18next.t('field.vas'), key: 'vas', width: 90, type: 'string' },
          width: 600
        },
        {
          type: 'string',
          name: 'type',
          header: i18next.t('field.type'),
          sortable: false,
          imex: { header: i18next.t('field.type'), key: 'type', width: 10, type: 'string' },
          width: 150
        },
        {
          type: 'number',
          name: 'vasQty',
          header: i18next.t('field.vas_qty'),
          sortable: false,
          imex: { header: i18next.t('field.vas_qty'), key: 'vasQty', width: 10, type: 'string' },
          width: 70
        }
      ]
    }
  }

  async pageInitialized() {
    this._releaseOrders = []
    this._partners = [...(await this._fetchPartners())]
    this._orderVass = []
    this._vasTypes = VAS_TYPES

    this._searchFields = this.searchFields
    this._config = this.reportConfig
  }

  pageUpdated(changes, lifecycle) {
    if (this.active) {
      this.report.fetch()
    }
  }

  async fetchHandler({ page, limit, sorters = [] }) {
    try {
      this._validate()
      const response = await client.query({
        query: gql`
          query vasReport($filters: [Filter!], $pagination: Pagination, $sortings: [Sorting!]) {
            vasReport(filters: $filters, pagination: $pagination, sortings: $sortings) {
              items {
                bizplace {
                  name
                }
                orderVasItem {
                  vas {
                    name
                    description
                    type
                  }
                  vasQty
                }
              }
            }
          }
        `,
        variables: {
          filters: [
            ...this.searchForm.queryFilters.map(filter => {
              switch (filter.name) {
                case 'fromDate':
                  let fromDt = new Date(filter.value)
                  fromDt.setHours(0)
                  filter.value = fromDt.toISOString()
                  break
                case 'toDate':
                  let toDt = new Date(filter.value)
                  toDt.setHours(23, 59, 59)
                  filter.value = toDt.toISOString()
                  break
                default:
                  break
              }

              return filter
            })
          ],
          pagination: { page, limit },
          sortings: sorters
        }
      })
      return {
        total: 0,
        records: response.data.vasReport.items.map(item => {
          return {
            ...item,
            bizplaceName: item.bizplace.name,
            vas: `${item.orderVasItem.vas.name}(${item.orderVasItem.vas.description})`,
            vasQty: item.orderVasItem.vasQty,
            type: item.orderVasItem.vas.type
          }
        })
      }
    } catch (e) {
      this._showToast(e)
    }
  }

  async _fetchPartners() {
    const filters = []
    const response = await client.query({
      query: gql`
        query partnersBizplaces($filters: [Filter!]) {
          partnersBizplaces(filters: $filters) {
            items {
              id
              name
              description
            }
          }
        }
      `,
      variables: { filters }
    })

    if (!response.errors) {
      const partners = response.data.partnersBizplaces.items
      if (partners.length == 1) {
        this._partnerId = partners[0].id
        this._partnerName = partners[0].name
      } else {
        this._partnerId = ''
        this._partnerName = ''
      }

      return partners
    }
  }

  _validate() {
    if (this._fromDateInput.value === '') {
      throw new Error(i18next.t('text.from_date_is_empty'))
    }
    if (this._toDateInput.value === '') {
      throw new Error(i18next.t('text.to_date_is_empty'))
    }
    if (new Date(this._fromDateInput.value) > new Date(this._toDateInput.value)) {
      throw new Error(i18next.t('text.to_date_cannot_be_before_from_date'))
    }
    if (!this.searchForm.shadowRoot.querySelector('form').checkValidity())
      throw new Error(i18next.t('text.invalid_form_value'))
    if (!this._bizplaceSelector.value) throw new Error(i18next.t('text.no_company_selected'))
  }

  _compareValues(key, order = 'asc') {
    return function innerSort(a, b) {
      if (!a.hasOwnProperty(key) || !b.hasOwnProperty(key)) {
        return 0
      }

      const varA = typeof a[key] === 'string' ? a[key].toUpperCase() : a[key]
      const varB = typeof b[key] === 'string' ? b[key].toUpperCase() : b[key]

      let comparison = 0
      if (varA > varB) {
        comparison = 1
      } else if (varA < varB) {
        comparison = -1
      }
      return order === 'desc' ? comparison * -1 : comparison
    }
  }

  _exportableData() {
    try {
      var headerSetting = [
        ...this.report._config.columns
          .filter(column => column.type !== 'gutter' && column.record !== undefined && column.imex !== undefined)
          .map(column => {
            return column.imex
          })
      ]

      return {
        header: headerSetting,
        data: this.report.data.records.map(record => {
          return flattenObject({
            ...record
          })
        }),
        groups: this.report._config.rows.groups,
        totals: this.report._config.rows.totals
      }
    } catch (e) {
      this._showToast(e)
    }
  }

  _modifyDateRange(e) {
    const fromDate = e.currentTarget.value

    if (this._toDateInput.value < fromDate) this._toDateInput.value = fromDate

    const minDate = new Date(fromDate)
    if (Number.isNaN(minDate.getTime())) return

    const min = formatLocalDate(minDate)
    this._toDateInput.min = min
  }

  _showToast({ type, message }) {
    document.dispatchEvent(
      new CustomEvent('notify', {
        detail: {
          type,
          message
        }
      })
    )
  }
}

window.customElements.define('vas-report', VasReport)
